VERSION 5.00
Begin VB.Form frmViewLinkTable 
   Caption         =   "Form1"
   ClientHeight    =   4200
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5325
   Icon            =   "ViewLinkTable.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4200
   ScaleWidth      =   5325
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdRsMove 
      Height          =   495
      Index           =   3
      Left            =   1440
      Picture         =   "ViewLinkTable.frx":000C
      Style           =   1  'Grafisch
      TabIndex        =   5
      Top             =   0
      Width           =   495
   End
   Begin VB.CommandButton cmdRsMove 
      Height          =   495
      Index           =   1
      Left            =   480
      Picture         =   "ViewLinkTable.frx":044E
      Style           =   1  'Grafisch
      TabIndex        =   4
      Top             =   0
      Width           =   495
   End
   Begin VB.CommandButton cmdRsMove 
      Height          =   495
      Index           =   0
      Left            =   0
      Picture         =   "ViewLinkTable.frx":0890
      Style           =   1  'Grafisch
      TabIndex        =   3
      Top             =   0
      Width           =   495
   End
   Begin VB.CommandButton cmdRsMove 
      Height          =   495
      Index           =   2
      Left            =   960
      Picture         =   "ViewLinkTable.frx":0CD2
      Style           =   1  'Grafisch
      TabIndex        =   2
      Top             =   0
      Width           =   495
   End
   Begin VB.TextBox txtField 
      Height          =   285
      Index           =   0
      Left            =   2040
      Locked          =   -1  'True
      TabIndex        =   1
      Top             =   600
      Visible         =   0   'False
      Width           =   3135
   End
   Begin VB.Label lblField 
      BackStyle       =   0  'Transparent
      Caption         =   "#"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   600
      Visible         =   0   'False
      Width           =   1695
   End
End
Attribute VB_Name = "frmViewLinkTable"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

' =======================================
' Beispiel flexible Tabellen-Verknuepfung
' =======================================
'
' zeigt den Inhalt einer nicht persistent
' verknuepften Tabelle in einer Tabelle
' an.
'
' verwendetet (Fremd-)Objekte:
'
'   ADODB:      ADO
' =======================================
Option Explicit

Private mCon    As ADODB.Connection
Private mRs     As ADODB.Recordset

' -----------------
' Form wird geladen
' -----------------
Private Sub Form_Load()
    Set mCon = New ADODB.Connection
    
    ' --- mit Datenbank verbinden ---
    With mCon
        ' --- Zugriffsoptionen setzen ---
        .CursorLocation = adUseClient
        .Mode = adModeReadWrite Or adModeShareDenyWrite
        
        ' --- Datenbanktyp und -namen festlegen ---
        .Provider = "Microsoft.Jet.OLEDB.3.51"
        .ConnectionString = "Data Source=C:\test.mdb"
        
        ' --- verbinden ---
        .Open
    End With
    
    ' ---     verknuepfte Tabelle im     ---
    ' --- Tabellensteuerelement anzeigen ---
    Set mRs = LinkTableNonPersistent( _
        "Test", _
        "C:\test.mdb", mCon)
    ArrangeControls mRs
    ShowData mRs
End Sub

' ------------------
' Form wird entladen
' ------------------
Private Sub Form_Unload(Cancel As Integer)
    ' --- Datenbankverbindung loesen ---
    ' ---    und Objekt vernichten   ---
    mRs.Close
    mCon.Close
    Set mRs = Nothing
    Set mCon = Nothing
End Sub

' --------------------------------
' Datensatzschaltflaeche betaetigt
' --------------------------------
Private Sub cmdRsMove_Click(Index As Integer)
    Select Case Index
        Case 0
            mRs.MoveFirst
        Case 1
            mRs.MovePrevious
        Case 2
            mRs.MoveNext
        Case 3
            mRs.MoveLast
    End Select
    
    ShowData mRs
End Sub

' ---------------------------------------------------
' Oeffnet eine Tabelle aus einer "fremden" Datenbank
'
' Parameter:
'
'   rsForeignTableName: Tabellenname in der Datenbank
'   rsForeignConnect:   Verbindungszeichenfolge
'   rcon:               Connection-Objekt
'
' Rueckgabe:
'
'   Recordset-Objekt, welches die zu persistent
' ---------------------------------------------------
Public Function LinkTableNonPersistent( _
    ByRef rsForeignTableName As String, _
    ByRef rsForeignConnect As String, _
    ByRef rcon As ADODB.Connection) As ADODB.Recordset
    
    Dim rs As ADODB.Recordset
    Set rs = New ADODB.Recordset
    
    ' --- Recordset oeffnen ---
    With rs
      .CursorType = adOpenDynamic
      .LockType = adLockOptimistic
      
      ' --- SQL-Statement zusammenbasteln ---
      .Open "SELECT * FROM [" & rsForeignTableName & _
        "] IN '" & rsForeignConnect & "'", rcon
    End With
    
    ' --- Rueckgabewert zuweisen ---
    Set LinkTableNonPersistent = rs
    Set rs = Nothing
End Function

Private Sub ArrangeControls(ByRef rrs As ADODB.Recordset)
    Dim i As Long
    
    For i = 0 To (rrs.Fields.Count - 1)
        If (i > 0) Then
            Load lblField(i)
            Load txtField(i)
            
            With lblField(i - 1)
                lblField(i).Move .Left, (.Top + .Height + 100)
            End With
            With txtField(i - 1)
                txtField(i).Move .Left, (.Top + .Height + 100)
            End With
        End If
        
        lblField(i).Caption = rrs.Fields(i).Name
        
        lblField(i).Visible = True
        txtField(i).Visible = True
    Next ' i
End Sub

' ----------------------------
' aktuellen Datensatz anzeigen
' ----------------------------
Private Sub ShowData(ByRef rrs As ADODB.Recordset)
    Dim i As Long
    
    On Error Resume Next
    
    ' --- Feldinhalte anzeigen ---
    For i = 0 To (mRs.Fields.Count - 1)
        txtField(i).Text = mRs(i).Value
    Next ' i
    
    ' --- Datensatzschaltflaechen ---
    ' --- aktivieren/deaktivieren ---
    cmdRsMove(0).Enabled = (Not mRs.BOF)
    cmdRsMove(1).Enabled = (Not mRs.BOF)
    cmdRsMove(2).Enabled = (Not mRs.EOF)
    cmdRsMove(3).Enabled = (Not mRs.EOF)
End Sub
